<script setup lang="ts">
import type { GeneSearchResult } from "~/composables/services/useGeneService";

type OrthologyList = Exclude<GeneSearchResult["orthologies"], undefined>;
const props = defineProps<{ orthologies: OrthologyList }>();
const allSpecies = computed(() => {
  const first = props.orthologies[0];
  if (!first) return [];
  return first.orthologs.map((o) => o.species);
});
const mainSpecies = useMainSpecies();
const speciesDisplay = (species: string) => {
  if (species === "Tcas") return "Tribolium";
  if (species === "Dmel") return "Drosophila";
  return species;
};
</script>

<template>
  <v-table>
    <thead>
      <tr>
        <th>Algorithm</th>
        <th v-for="s in allSpecies" :key="s">
          {{ speciesDisplay(s) }} homologs
        </th>
        <th class="text-no-wrap">Link to tree</th>
      </tr>
    </thead>
    <tbody>
      <tr
        v-for="{ group, source, orthologs } in props.orthologies"
        :key="source + ':' + group"
      >
        <td>{{ source }}</td>
        <td v-for="{ species, genes } in orthologs" :key="species">
          <span
            v-for="{ gene, synonyms } in genes"
            :key="gene"
            class="text-no-wrap"
          >
            <template v-if="species === mainSpecies">
              <IBBGeneId :gene="gene" />
            </template>
            <template v-else-if="species === 'Dmel'">
              <FlybaseGeneId :gene="gene" />
            </template>
            <template v-else>
              {{ gene }}
            </template>
            <span v-if="synonyms && synonyms.length > 0">
              ({{ synonyms.join(", ") }})
            </span>
            <span class="d-inline-block"> &nbsp; </span>
          </span>
        </td>
        <td>
          <OutLink
            v-if="source.toLowerCase() === 'eggnog6'"
            :text="group"
            :to="`http://eggnog6.embl.de/search/ogs/${group}/`"
          />
        </td>
      </tr>
    </tbody>
  </v-table>
</template>
